# PhasicFlow: cylinder Class Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

cylinder Class Reference
Collaboration diagram for cylinder:
[legend]

## Public Member Functions

| TypeInfoNV ("cylinder")
FUNCTION_H | cylinder (const realx3 &p1, const realx3 &p2, const real radius)
FUNCTION_H | cylinder (const dictionary &dict)
FUNCTION_H | cylinder (iIstream &is)
FUNCTION_HD | cylinder (const cylinder &)=default
FUNCTION_HD | cylinder (cylinder &&)=default
FUNCTION_HD cylinder & | operator= (const cylinder &)=default
FUNCTION_HD cylinder & | operator= (cylinder &&)=default
| ~cylinder ()=default
INLINE_FUNCTION_HD bool | isInside (const realx3 &point) const
const INLINE_FUNCTION_HD realx3 & | p1 () const
const INLINE_FUNCTION_HD realx3 & | p2 () const
INLINE_FUNCTION_HD realx3 | minPoint () const
INLINE_FUNCTION_HD realx3 | maxPoint () const
INLINE_FUNCTION_HD real | radius () const
FUNCTION_H bool | read (iIstream &is)
FUNCTION_H bool | write (iOstream &os) const
FUNCTION_H bool | read (const dictionary &dict)
FUNCTION_H bool | write (dictionary &dict) const

## Protected Member Functions

FUNCTION_H bool | calculateParams ()

## Protected Attributes

realx3 | p1_
realx3 | p2_
real | radius2_
realx3 | axisVector_
real | axisVector2_
realx3 | minPoint_
realx3 | maxPoint_

## Detailed Description

Definition at line 32 of file cylinder.hpp.

## Constructor & Destructor Documentation

## cylinder() [1/5]

FUNCTION_H cylinder | ( | const realx3 & | p1,
|  | const realx3 & | p2,
|  | const real | radius
| ) |  |

Definition at line 57 of file cylinder.cpp.

References cylinder::calculateParams(), pFlow::endl(), fatalErrorInFunction, and fatalExit.

Here is the call graph for this function:

## cylinder() [2/5]

FUNCTION_H cylinder | ( | const dictionary & | dict | ) |

Definition at line 76 of file cylinder.cpp.

References pFlow::endl(), fatalErrorInFunction, fatalExit, dictionary::getVal(), and dictionary::globalName().

Here is the call graph for this function:

## cylinder() [3/5]

FUNCTION_H cylinder | ( | iIstream & | is | ) |

Definition at line 103 of file cylinder.cpp.

References fatalExit, ioErrorInFile, IOstream::lineNumber(), and IOstream::name().

Here is the call graph for this function:

## cylinder() [4/5]

FUNCTION_HD cylinder | ( | const cylinder & |  | ) |

default

## cylinder() [5/5]

FUNCTION_HD cylinder | ( | cylinder && |  | ) |

default

## ~cylinder()

~cylinder | ( |  | ) |

default

## Member Function Documentation

## calculateParams()

FUNCTION_H bool calculateParams | ( |  | ) |

protected

Definition at line 27 of file cylinder.cpp.

References cylinder::axisVector2_, cylinder::axisVector_, dot(), pFlow::max(), cylinder::maxPoint_, pFlow::min(), cylinder::minPoint_, cylinder::p1_, cylinder::p2_, cylinder::radius2_, pFlow::smallValue, pFlow::sqrt(), and zAxis::transferBackZ().

Referenced by cylinder::cylinder().

Here is the call graph for this function:
Here is the caller graph for this function:

## TypeInfoNV()

TypeInfoNV | ( | "cylinder" |  | ) |

## operator=() [1/2]

FUNCTION_HD cylinder& operator= | ( | const cylinder & |  | ) |

default

## operator=() [2/2]

FUNCTION_HD cylinder& operator= | ( | cylinder && |  | ) |

default

## isInside()

INLINE_FUNCTION_HD bool isInside | ( | const realx3 & | point | ) | const

inline

Definition at line 88 of file cylinder.hpp.

References cylinder::axisVector2_, cylinder::axisVector_, cross(), dot(), cylinder::p1_, and cylinder::radius2_.

Referenced by cylinderRegion::peek().

Here is the call graph for this function:
Here is the caller graph for this function:

## p1()

const INLINE_FUNCTION_HD realx3& p1 | ( |  | ) | const

inline

Definition at line 111 of file cylinder.hpp.

References cylinder::p1_.

## p2()

const INLINE_FUNCTION_HD realx3& p2 | ( |  | ) | const

inline

Definition at line 117 of file cylinder.hpp.

References cylinder::p2_.

## minPoint()

INLINE_FUNCTION_HD realx3 minPoint | ( |  | ) | const

inline

Definition at line 123 of file cylinder.hpp.

References cylinder::minPoint_.

Referenced by cylinderRegion::peek().

Here is the caller graph for this function:

## maxPoint()

INLINE_FUNCTION_HD realx3 maxPoint | ( |  | ) | const

inline

Definition at line 129 of file cylinder.hpp.

References cylinder::maxPoint_.

Referenced by cylinderRegion::peek().

Here is the caller graph for this function:

## radius()

INLINE_FUNCTION_HD real radius | ( |  | ) | const

inline

Definition at line 135 of file cylinder.hpp.

References cylinder::radius2_, and pFlow::sqrt().

Here is the call graph for this function:

## read() [1/2]

FUNCTION_H bool read | ( | iIstream & | is | ) |

Definition at line 117 of file cylinder.cpp.

References iIstream::nextData().

Referenced by pFlow::operator>>().

Here is the call graph for this function:
Here is the caller graph for this function:

## write() [1/2]

FUNCTION_H bool write | ( | iOstream & | os | ) | const

Definition at line 128 of file cylinder.cpp.

References IOstream::check(), FUNCTION_NAME, pFlow::sqrt(), and iOstream::writeWordEntry().

Referenced by pFlow::operator<<().

Here is the call graph for this function:
Here is the caller graph for this function:

## read() [2/2]

FUNCTION_H bool read | ( | const dictionary & | dict | ) |

Definition at line 138 of file cylinder.cpp.

References dictionary::getVal().

Here is the call graph for this function:

## write() [2/2]

FUNCTION_H bool write | ( | dictionary & | dict | ) | const

Definition at line 151 of file cylinder.cpp.

References dictionary::add(), pFlow::endl(), fatalErrorInFunction, dictionary::globalName(), and pFlow::sqrt().

Here is the call graph for this function:

## Member Data Documentation

## p1_

realx3 p1_

protected

Definition at line 37 of file cylinder.hpp.

Referenced by cylinder::calculateParams(), cylinder::isInside(), and cylinder::p1().

## p2_

realx3 p2_

protected

Definition at line 40 of file cylinder.hpp.

Referenced by cylinder::calculateParams(), and cylinder::p2().

## radius2_

real radius2_

protected

Definition at line 43 of file cylinder.hpp.

Referenced by cylinder::calculateParams(), cylinder::isInside(), and cylinder::radius().

## axisVector_

realx3 axisVector_

protected

Definition at line 45 of file cylinder.hpp.

Referenced by cylinder::calculateParams(), and cylinder::isInside().

## axisVector2_

real axisVector2_

protected

Definition at line 47 of file cylinder.hpp.

Referenced by cylinder::calculateParams(), and cylinder::isInside().

## minPoint_

realx3 minPoint_

protected

Definition at line 49 of file cylinder.hpp.

Referenced by cylinder::calculateParams(), and cylinder::minPoint().

## maxPoint_

realx3 maxPoint_

protected

Definition at line 51 of file cylinder.hpp.

Referenced by cylinder::calculateParams(), and cylinder::maxPoint().

The documentation for this class was generated from the following files:

- src/phasicFlow/structuredData/cylinder/cylinder.hpp
- src/phasicFlow/structuredData/cylinder/cylinder.cpp